﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.CodeDom.Compiler;


namespace DynamicCompile
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void btnStart_Click(object sender, EventArgs e)
		{
			if ("" == textBox1.Text)
			{
				//분석할 데이터가 비어있다.
				//에러와 리턴
				textBox2.Text = "내용이 없습니다.";
				return;
			}

			StartCompile();

		}

		/// <summary>
		/// 컴파일을 시작합니다.
		/// </summary>
		public void StartCompile()
		{
			string sErrMsg ="";
			CodeDomProvider codeDom;
			//출력 형식 true == EXE
			bool bOutType = true;
			//출력 경로
			string sDir = "";
			
			//언어 구성 확인
			if (true == CodeDomProvider.IsDefinedLanguage(cbLanguage.Text))
			{
				//컴파일러 객체 생성
				codeDom = CodeDomProvider.CreateProvider(cbLanguage.Text);
			}
			else
			{
				textBox2.Text = "이 언어에대한 구성이 없습니다.";
				return;
			}
			
			//출력타입확인
			switch (cbType.Text.ToUpper())
			{
				case "EXE":
					bOutType = true;
					sDir = ".exe";
					break;
				case "DLL":
					bOutType = false;
					sDir = ".dll";
					break;
				default:
					textBox2.Text = "출력 형식이 잘못 되었습니다.";
					return;
			}

			// 컴파일러 파라미터 옵션 지정
			CompilerParameters cparams = new CompilerParameters();
			cparams.GenerateExecutable = bOutType;
			//전체 출력 경로
			cparams.OutputAssembly = textBox3.Text + txtFileName.Text + sDir;

			// 소스코드를 컴파일해서 EXE 생성
			CompilerResults results 
				= codeDom.CompileAssemblyFromSource(cparams, Texts(textBox1.Text));

			// 컴파일 에러 있는 경우 표시
			if (results.Errors.Count > 0)
			{
				sErrMsg = "Error : " + results.Errors.Count + "\r\n\r\n";
				
				foreach (var err in results.Errors)
				{
					sErrMsg += err.ToString() + "\r\n";
				}
			}
			else
			{
				//에러 없음
				sErrMsg = "컴파일 완료";
			}

			textBox2.Text = sErrMsg;
          
		}

		/// <summary>
		/// 입력된 데이터의 개행문자를 지워 준다.
		/// </summary>
		/// <param name="sData"></param>
		/// <returns></returns>
		private string Texts(string sData)
		{
			string sReturn = @"" + sData;

			return sReturn;
		}

		private void btnOpenFolder_Click(object sender, EventArgs e)
		{
			//폴더 찾기
			FolderBrowserDialog fbdFold = new FolderBrowserDialog();

			if( "" == textBox3.Text )
			{
				//내용이 없으면 기본 값을 넣어 준다.
				fbdFold.SelectedPath = @"c:\";
			}
			else
			{
				fbdFold.SelectedPath = textBox3.Text;
			}

			if (System.Windows.Forms.DialogResult.OK == fbdFold.ShowDialog())
			{
				textBox3.Text = fbdFold.SelectedPath + "\\";
			}
			else
			{
				textBox2.Text = "폴더 경로가 잘못 되었습니다.";
			}
			
		}

	}
}
